const itemsArray = require('./itemsArray.js').default;
const commands = require('commands');

export default class {
  constructor() {
    this.items = [];
    this.settings = [];
    this.action = this.action.bind(this);

    // ファイルを取得
    this._created();
  }

  action(selection) {
    const defaultSelection = selection.items;
    selection.items.forEach((node) => {
      selection.items = itemsArray(node, selection, this.settings);
      commands.convertToPath();
    });
    // グループの変更等により参照出来ない場合はselectionを外す
    try {
      selection.items = defaultSelection
    }
    catch(e) { selection.items = null }
  }

  async _created() {
    const fs = require('uxp').storage.localFileSystem;
    const settings = require('./panels/settings.json');
    try {
      const folder = await fs.getDataFolder();
      const file = await folder.getEntry('settings.json');
      const json = await file.read();
      this.settings = JSON.parse(json);
    }
    catch(e) {
      this.settings = settings;
    }
  }

  _setSettingsFile(settings) {
    this.settings = settings;
  }
}
