const commands = require('commands');

function checkOutline(name, settings) {
  const set = settings.filter(x => x.value === name);
  return set.length ? set[0].prop : true;
}

function setOption(node, type, settings, selection) {
  const set = settings.filter(x => x.value === type);
  const flag = set.length ? set[0].prop : false;
  let bool = false;
  if(flag) {
    switch(type) {
      // case 'isMask':
      //   break;
      case 'isLink':
      case 'isRepeat':
        selection.items = node;
        commands.ungroup();
        bool = true;
        break;
      case 'isLock':
        node.locked = false;
        break;
      case 'isLayer':
        node.removeFromParent();
        bool = true;
        break;
    }
  }
  return bool;
}

export default function(block, selection, settings) {
  let items = [];

  function recursion(node, beforeMaskArray = undefined) {
    const name = node.constructor.name;

    // 非表示、ロックレイヤーを処理
    if(node.visible === false) {
      setOption(node, 'isLayer', settings, selection);
      return;
    }
    if(node.locked  === true) {
      if(setOption(node, 'isLock', settings, selection)) return;
    }

    // 対象のファイルをチェック
    if(name !== 'Group' && name !== 'Artboard') {
      switch (name) {
        case 'LinkedGraphic':
          if(setOption(node, 'isLink', settings, selection)) {
            node = selection.items;
          }
          break;
        case 'RepeatGrid':
          if(setOption(node, 'isRepeat', settings, selection)) {
            selection.items.forEach((childNode) => recursion(childNode));
          }
          break;
      }
      if(checkOutline(name, settings) === false) return;
    }

    switch(name) {
      case 'Artboard':
      case 'Group':
        if(node.mask ? true : false) {
          // maskConvert(node, beforeMaskArray);
        }
        else if(node.hasLinkedContent === true) {
          // LinkedConvert(node);
        }
        else {
          node.children.forEach((childNode) => recursion(childNode));
        }
        break;
      case 'RepeatGrid':
        // repeatConvert(node);
        break;
      case 'SymbolInstance':
        // symbolConvert(node);
        break;
      case 'LinkedGraphic':
        // LinkedConvert(node);
        break;
      default:
        items.push(node);
    }
  }
  recursion(block);

  /*

  function maskConvert(node, beforeMaskArray) {
    let itemMasks = [];
    let itemParent = node.parent;

    beforeMaskArray = beforeMaskArray || [];

    selection.items = node;
    commands.ungroup();

    selection.items.forEach((childNode) => roop(childNode));

    selection.items = itemMasks;
    commands.convertToPath();

    selection.items = selection.items.map((childNode) => {
      function returnGroup(subNode) {
        return subNode.parent
          && subNode.parent.constructor.name === 'Group'
          && itemParent !== subNode.parent
            ? returnGroup(subNode.parent)
            : subNode;
      }
      return returnGroup(childNode);
    }).filter((x, i, self) => self.indexOf(x) === i);

    if(beforeMaskArray && 1 <= beforeMaskArray.length) {
      selection.items = selection.items.concat(beforeMaskArray);
      beforeMaskArray = [];
    }

    commands.createMaskGroup();

    beforeMaskArray.push(selection.items[0]);
    items.push(selection.items[0]);

    function roop(node) {
      if(node.constructor.name === 'Group' && 'fill' in node === false) {
        node.mask
          ? recursion(node, beforeMaskArray)
          : node.children.forEach((childNode) => roop(childNode));
      }
      else {
        itemMasks.push(node);
      }
    }
  }

  function repeatConvert(node) {
    selection.items = node;
    commands.ungroup();
    commands.group();
    recursion(selection.items[0]);
  }

  function symbolConvert(node) {
    selection.items = node;
    commands.ungroup();
    if(2 <= selection.items.length) commands.group();
    node = selection.items[0];
    recursion(node);
  }

  function LinkedConvert(node) {
    commands.ungroup();
    if(2 <= selection.items.length) commands.group();
    node = selection.items[0];
    recursion(node);
  }

  */

  return items;
}
