const { VueLoaderPlugin } = require("vue-loader");

module.exports = {
  entry: "./src/main.js",
  output: {
    path: __dirname,
    filename: 'main.js',
    libraryTarget: "commonjs2"
  },
  devtool: "none",
  module: {
    rules: [
      {
        test: /\.css$/,
        use: ["vue-style-loader", "css-loader"]
      },
      {
        test: /\.vue$/,
        loader: "vue-loader"
      },
      {
        test: /\.js$/,
        loader: "babel-loader",
        options: {
          presets: [
            "@babel/preset-env"
          ]
        }
      },
      {
        test: /\.json$/,
        loader: "json-loader",
        type: "javascript/auto"
      }
    ]
  },
  externals: {
    scenegraph: "scenegraph",
    commands: "commands",
    application: "application",
    uxp: "uxp"
  },
  plugins: [
    new VueLoaderPlugin()
  ]
};
